program uzduotis_2_SUDOKU;
{ ---------------------------------------------------------------------------- }
const max = 9;
      // impossible.txt | hard.txt | worlds_hardest.txt
      f1 = 'hard.txt';
      f2 = 'out.txt';
{ ---------------------------------------------------------------------------- }
type tinka = array [1..max] of boolean;
type sarasas = record
                 reiksme : integer;
                 galimi : tinka;
               end;
type sudoku = array [1..max,1..max] of sarasas;
{ ---------------------------------------------------------------------------- }
procedure galimybes(var A : sudoku);
var x, y, i : integer ;
begin
  for x := 1 to max do
    begin
      for y := 1 to max do
        begin
          for i := 1 to max do
            begin
              A[x,y].galimi[i] := true;
          end;
      end;
  end;
end;
{ ---------------------------------------------------------------------------- }
procedure priklausomumas(var T : sudoku; x, y, sk : integer);
var tarp_x, tarp_y, i, j : integer;
begin
  if sk <> 0 then
    begin
      for i := 1 to max do
        begin
          T[x,i].galimi[sk] := false;
          T[i,y].galimi[sk] := false;
      end;
      tarp_x := ((x - 1) div 3) * 3 + 1;
      tarp_y := ((y - 1) div 3) * 3 + 1;
      for i := tarp_x to tarp_x + 2 do
        for j := tarp_y to tarp_y + 2 do
          T[i,j].galimi[sk] := false;
      for i := 1 to max do
        T[x,y].galimi[i] := false;
      end;
end;
{ ---------------------------------------------------------------------------- }
procedure skaitymas(var A : sudoku; var f : text; var klaida : boolean);
var x, y : integer;
begin
  klaida := false;
  galimybes(A);
  for x := 1 to max do
    begin
      for y := 1 to max do
        begin
          Read(f, A[x,y].reiksme);
          if (A[x,y].reiksme <> 0) and not A[x,y].galimi[A[x,y].reiksme] then
            klaida := true;
          priklausomumas (A, x, y, A[x,y].reiksme);
      end;
      ReadLn(f);
  end;
end;
{ ---------------------------------------------------------------------------- }
procedure irasymas(var A : sudoku; var f : text);
var x, y : integer;
begin
  for x := 1 to max do
    begin
      for y := 1 to max do
        begin
          Write(f, A[x,y].reiksme, ' ');
      end;
      WriteLn(f);
  end;
end;
{ ---------------------------------------------------------------------------- }
procedure spausdinimas(var A : sudoku);
var x, y, z : integer;
begin
  z := 0;
  for x := 1 to max do
    begin
      if(z <> 0) and (z mod 3 = 0) and (z <> max) then
        WriteLn('------+-------+------');
      z := z + 1;
      for y := 1 to max do
        begin
          Write(A[x,y].reiksme, ' ');
          if (y mod 3 = 0) and (y <> max) then write('| ');

      end;
      WriteLn();
  end;
end;
{ ---------------------------------------------------------------------------- }
function pabaiga(A : sudoku) : boolean;
var x, y : integer;
begin
  pabaiga := true ;
  for x := 1 to max do
    for y := 1 to max do
      if A[x,y].reiksme = 0 then pabaiga := false ;
end;
{ ---------------------------------------------------------------------------- }
function imanomas(A : sudoku) : boolean;
var x, y, i : integer ;
    laisvas : boolean ;
begin
  imanomas := false ;
  laisvas := false ;
  for x := 1 to max do
    for y := 1 to max do
      if A[x,y].reiksme = 0 then
        begin
          laisvas := false ;
          for i := 1 to max do
            begin
              laisvas := laisvas or A[x,y].galimi[i];
          end;
          if not laisvas then imanomas := true;
    end;
end;
{ ---------------------------------------------------------------------------- }
procedure langeliai(var A : sudoku; var rezultatas : boolean);
var x, y, i, kiek, tarp_i : integer;
begin
  rezultatas := false;
  for x := 1 to max do
    for y := 1 to max do
      if A[x,y].reiksme = 0 then
        begin
          tarp_i := 0;
          kiek := 0;
          for i := 1 to max do
            if A[x,y].galimi[i] then
              begin
                tarp_i := i;
                kiek := kiek + 1;
            end;
            if kiek = 1 then
              begin
                A[x,y].reiksme := tarp_i;
                priklausomumas (A, x, y, A[x,y].reiksme);
                rezultatas := true;
            end;
      end;
end;
procedure spresk(var A : sudoku; var rezultatas : boolean); forward;
{ ---------------------------------------------------------------------------- }
//Pagal S.Ragaisio pasiulyma, "backtrack" budas
procedure speliok(var A : sudoku; var rezultatas : boolean);
var x, y, i : integer;
    rezultatas2 : boolean;
    T : sudoku;
begin
  rezultatas := false;
  if not pabaiga(A) then
    begin
      for x := 1 to max do
        for y := 1 to max do
          if A[x,y].reiksme = 0 then
            begin
              for i := 1 to max do
                begin
                  if A[x,y].galimi[i] and not rezultatas then
                    begin
                      T := A;
                      T[x,y].reiksme := i;
                      priklausomumas(T, x, y, T[x,y].reiksme);
                      spresk(T, rezultatas2);
                      if rezultatas2 then
                        begin
                          if not pabaiga(T) then rezultatas := false
                          else
                            begin
                              rezultatas := true;
                              A := T;
{!}                           //spausdinimas(A);
                          end;
                      end
                      else
                        begin
                          T := A;
                      end;
                  end;
              end;
              if not rezultatas then
                begin
                  rezultatas := true;
                  T := A;
{!}               //spausdinimas(A);
              end;
          end;
  end
  else rezultatas := false;
end;
{ ---------------------------------------------------------------------------- }
procedure pradek(var A : sudoku; var rezultatas : boolean);
var testi : boolean;
begin
  rezultatas := false;
  testi := true;
  While testi do
    begin
      langeliai( A, testi);
      if testi then rezultatas := true;
  end;
end;
{ ---------------------------------------------------------------------------- }
procedure spresk(var A : sudoku; var rezultatas : boolean);
begin
  pradek(A, rezultatas);
  if imanomas (A) then rezultatas := false
  else
    begin
      if pabaiga(A) then  rezultatas := true
      else speliok(A, rezultatas);
  end;
end;
{ ---------------------------------------------------------------------------- }
var A : sudoku;
    f, d : text;
    rezultatas, klaida : boolean;
begin
  Assign(f, f1);
  Reset(f);
  skaitymas(A, f, klaida);
  spausdinimas(A);
  WriteLn();
  if klaida then WriteLn('Blogi SUDOKU duomenys!')
  else
    begin
      spresk(A, rezultatas);
      if rezultatas then
        begin
          spausdinimas(A);
          Assign(d, f2);
          Rewrite(d);
          irasymas(A, d);
          Close(d);
      end
      else WriteLn('Sio SUDOKU neimanoma isspresti!');
      WriteLn();
  end;
  Close(f);
  ReadLn();
end.
